#!/usr/bin/perl -w 

#
# $Id: reinstall.pm,v 1.1 2002/04/08 17:41:57 skud Exp $
#

package    esmith::FormMagick::Panel::reinstall;

use strict;
use esmith::FormMagick;
use esmith::util;
use File::Basename;
use Exporter;
use Carp;

our @ISA = qw(esmith::FormMagick Exporter);

our @EXPORT = qw( make_disk);

our $VERSION = sprintf '%d.%03d', q$Revision: 1.1 $ =~ /: (\d+).(\d+)/;


=pod 

=head1 NAME

esmith::FormMagick::Panels::reinstall - useful panel functions

=head1 SYNOPSIS

    use esmith::FormMagick::Panels::reinstall;

    my $panel = esmith::FormMagick::Panel::reinstall->new();
    $panel->display();

=head1 DESCRIPTION

=cut

# {{{ new

=head2 new();

Exactly as for esmith::FormMagick

=begin testing


use_ok('esmith::FormMagick::Panel::reinstall');
use vars qw($panel);
ok($panel = esmith::FormMagick::Panel::reinstall->new(), "Create panel object");
isa_ok($panel, 'esmith::FormMagick::Panel::reinstall');

=end testing

=cut



sub new {
    shift;
    my $self = esmith::FormMagick->new();
    $self->{calling_package} = (caller)[0];
    bless $self;
    return $self;
}

# }}}

=head1 ACTION

=head2 make_disk

        Writes out a new recovery disk to the system's primary floppy drive.

=cut



sub make_disk {
    my ($fm) = @_;

    my $q = $fm->{'cgi'};
    
    my $msg = "";

    # Check mount table to see if floppy is mounted
    if (open(MT, "</proc/mounts")) {
	while (<MT>) {
	    if (/^\/dev\/fd0/) {
                $fm->{cgi}->param( -name => 'wherenext', 
			           -value => 'AlreadyMountedFailure' );
                return();
                }
	    }
        
	unless (close(MT)) {
                $fm->{cgi}->param( -name => 'wherenext', 
				   -value => 'MountCloseFailure' );
                return();
	}
    }
    else {
                $fm->{cgi}->param( -name => 'wherenext', -value => 'MountOpenFailure' );
                return();
    } 

    unless (open (FD, ">/dev/fd0")) {
                $fm->{cgi}->param( -name => 'wherenext', -value => 'FloppyOpenFailure' );
                return();

    }
    close (FD);
    #------------------------------------------------------------
    # Signal the create reinstallation disk event
    #------------------------------------------------------------

    system ("/sbin/e-smith/signal-event", "reinstall-disk") == 0
	or die ("Error occurred while creating the reinstallation diskette.\n");

    $fm->{cgi}->param( -name => 'wherenext', -value => 'Done');
}


1;


